//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
// NOTE!!! relies on quikGL class!!!
//
// quikMeshImg.h: interface for the CquikMeshImg class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUIKMESHIMG_H__FE0F53A2_3C3D_4B3D_8B0A_FA42D7EC4B60__INCLUDED_)
#define AFX_QUIKMESHIMG_H__FE0F53A2_3C3D_4B3D_8B0A_FA42D7EC4B60__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CquikMeshImg  
//==============================================================================
// 3D distortable image; holds a rectangular grid of vertices and a texture map
// image that is applied to it.  Initially a flat 'billboard' placed in 3D, 
// changing vertex positions in grid stretches to any 3D shape.  
{
public:
	CquikMeshImg();							// Constructor, initializer
	virtual ~CquikMeshImg();				// Destructor (default)

											// Image:
	GLint m_Txsize,m_Tysize,m_Tzsize;		// # of pixels, # of colors/pix
	GLubyte *m_pTimg;						// Ptr to the texture image
											// Mesh:
	GLint m_Mxsize,m_Mysize;				// # of vertices in the mesh.
private:
	GLfloat *m_pNorm, *m_pTexy, *m_pVert;	// pointers to dyn. alloc'd array 
											// of normal vectors, texture coords
											// and vertices for the mesh.
public:
	void SaveFile(OPENFILENAME *pName);
	void LoadFile(OPENFILENAME *pName);
	void sizer(int imgX, int imgY, int meshX, int meshY); // set image & mesh
											// size, reallocating as needed.
	void wipe(void);						// Discard any contents, release
											// any memory we have allocated.

	void makeTestImgMeshDisplayList(void);	// Generate a test pattern texture.				
	void makeTestImgMesh(void);				// Generate a test pattern texture.
	void drawMe(void);						// call this only from within 
											// CquikGL::drawOpenGL() only.
	void meshWrinkle(float zoffset);		// Offset alternating mesh verts.			
	void error_GL(char *label);				// Report last openGL error, if any
											//(same as quikGL::errorGL())
};

#endif // !defined(AFX_QUIKMESHIMG_H__FE0F53A2_3C3D_4B3D_8B0A_FA42D7EC4B60__INCLUDED_)
